$(document).ready(function() {
  contactForm();

  if (window.location.search == '?nexturl') {
    $.magnificPopup.open({
      items: {
        src: '#next-url', // can be a HTML string, jQuery object, or CSS selector
        type: 'inline'
      }
    });

    setTimeout(function () {
      $.magnificPopup.close();
    }, 10000)
  }

  $('[href*="https://app.ekam.ru/registration"]').each(function(index, el) {
    var href = $(this).attr('href');
    var uuid = 'uuid='+generateUUID();
    if (href.indexOf('?')>-1) {
      href = href+'&'+uuid;
    }else{
      href = href+'?'+uuid;
    }
    //Записываем реферер из кук
    var landing_page = $.cookie('first_current_location').split('?')[0];
    if (landing_page) {
      href += '&landing_page=ekam.ru' + landing_page
    }
    var utm_fields = $.cookie('first_current_location').split('?')[1];
    if (utm_fields) {
      href += '&' + utm_fields
    }
    var referer_url = $.cookie('first_referer');
    if (referer_url.length > 1) {
      href += '&referer_url=' + referer_url;
    }
    href += '&registration_page=' + location.href
    $(this).attr('href', href);
  });
});




function contactForm() {
  // состоние
  var isSavedLead = false; // первая отправка телефона

  // Состояние целей
  var goalForm = {
    step1: true,
    step2: true,
    step3: true,
    step4: true
  }

  // Удалить уведомление об ошибке
  $(document).on('click', '.control-error-clear', function(event) {
    event.preventDefault();
    var $control = $(this).parents('.form-control');
    $control.removeClass('is-error');
    $control.find('.control-error').remove();
    $control.find('.control-error-clear').remove();
  });

  // Валидация
  $(document).on('focusout change input.mask paste.mask input keyup', '.form-control input', function(event) {
    //event.preventDefault();
    checkField($(this), function () {

    }, function () {

    }, event);
  });

  // проверить поле на ошибку
  function checkField($field, doneCallback, errorCallback, event) {
    var $control = $field.parents('.form-control');
    var ignore = ['keyup', 'input'];
    if (typeof doneCallback == "undefined") {
      doneCallback = function () {}
    }
    if (typeof errorCallback == "undefined") {
      errorCallback = function () {}
    }

    testField($field,
    function done(type) {
      doneCallback($field)
      if (type == 'phone') {
        $('.contact-step-2').removeClass('hide');
      }
      $control.addClass('is-done').removeClass('is-error');
      $control.find('.control-error').remove();
      $control.find('.control-error-clear').remove();
    },
    function fail(error) {
      var eventType = (event) ? event.type : '00000000';
      if (ignore.indexOf(eventType) == -1) {
        $control.addClass('is-error').removeClass('is-done');
        var withError = $control.find('.control-error').length;
        if (!withError) {
          $control.append(
          $("<div/>", {
              "class": "control-error",
              "html": error
            })
          )
          $control.append(
          $("<button/>", {
              "class": "control-error-clear",
              "html": '&times;'
            })
          )
        }else {
          $control.find('.control-error').html(error)
        }
      }

      errorCallback($field)

    })
  }

  // Отправка формы
  $(document).on('submit', '.contact-action', function(event) {
    event.preventDefault();
    submitFormReg(event)
  });

  // Обработчик отправки формы
  function submitFormReg(event) {
    var $form = $(event.target).parents('.contact');
    var notError = true;
    var PHONE, NAME, LAST_NAME, EMAIL_WORK;

    $form.find('input').each(function(index, el) {
      checkField($(el),
      function ($field) {

        var type = $field.data('validate');
        switch (type) {
          case 'phone':
            // телефон проходит валидацию не везде
            if ($form.is('[data-validate-phone]') || $form.find('[data-validate="phone"]').length > 0 && $('body').hasClass('page-is-rates') || $form.find('[data-validate="phone"]').length > 0 && $('body').hasClass('page-is-online-kassy') || $form.is('[data-use-bitrix]')) {
              PHONE = $field.val()
            }
            break;
          case 'string':
            if ($('body').hasClass('page-is-rates')) {
              var valueName = $field.val().split(' ');
              NAME = valueName[0];
              if (valueName[1]) {
                LAST_NAME = valueName[1]
              }
            }
            break;
          case 'contact':
            var fake = $field.val();
            if(fake != ''){
              notError = false;
            }
            break;
          case 'email':
            EMAIL_WORK = $field.val();
            break;
          // case 'checkbox':
          // //   EMAIL_WORK = $field.val();
          //   break;
          default:

        }
      },
      function () {
        notError = false;
      });
    });

    if (notError) {

      isSavedLead = false;
      if (goalForm.step4) {
        sendYaEvent('lead_step_4');
        goalForm.step4 = false;
      }
      if ($form.parents('#contact-modal').length) {
            sendYaEvent('free_done_modal');
          } else if ($form.is('.in-footer')) {
            sendYaEvent('free_done_article');
            console.log('free_done_article')
          } else if ($form.is('.in-online')) {
            sendYaEvent('free_done_online');
            console.log('free_done_online')
          }else{

          }
        var get_param = $form.find('.js-get_param').val();
        var mainEvent = $form.data('ya-goal');
        var get_param_handle = $form.find('.js-get_param_handle').val();
        var main_url = 'https://app.ekam.ru/registration?';
        var next = main_url;

      	if(mainEvent){
          sendYaEvent(mainEvent)
        }


        if (EMAIL_WORK) {
          next += 'email='+EMAIL_WORK;
        }
        if (typeof get_param == 'string' && get_param != '') {
          next += '&rate=' + get_param;
        }
        if (typeof get_param_handle == 'string' && get_param_handle != '') {
          next += '&plan_handle=' + get_param_handle;
        }

        if (NAME) {
          next += '&registration_name=' + NAME;
        }
        if (PHONE) {
          next += '&registration_phone=' + PHONE.replace(/\D/g, '');
        }

      	next += '&uuid=' + generateUUID();

        //Записываем реферер из кук
        var landing_page = $.cookie('first_current_location').split('?')[0];
        if (landing_page) {
          next += '&landing_page=ekam.ru' + landing_page
        }
        var utm_fields = $.cookie('first_current_location').split('?')[1];
        if (utm_fields) {
          next += '&' + utm_fields
        }
        var referer_url = $.cookie('first_referer');
        if (referer_url.length > 1) {
          next += '&referer_url=' + referer_url;
        }
      
        next += '&registration_page=' + location.href;

        if (window.location.pathname == '/page/online' || window.location.pathname == '/page/ecom' || window.location.pathname == '/page/online-kassa') {
          openNewTabOrNewWindow(window.location.pathname + '?nexturl');
          window.location.href = next;
          return;
        }
      
       
      

      	 if (window.location.pathname == '/page/online-kassa') {
            $form.append('<div class="ff-done">Спасибо! В ближайшее время с Вами свяжутся, ожидайте звонка.</div>');
            setTimeout(function () {
              $('.ff-done').remove();
            }, 3000)
            console.log(next)
            window.location.href = next;
            return;
          }




        if (typeof get_param_handle == 'string' && get_param_handle != '') {
          window.location.href = next;
          return;
        }

        window.location.href = next;

        goalForm = {
          step1: false,
          step2: false,
          step3: false,
          step4: false
        }
      //saveLead(PHONE, NAME, LAST_NAME, EMAIL_WORK, function () {
        //console.log('doneCallback');


      //})
    }
  }

  $(document).on('keyup', '.contact input', function(event) {
    if(event.keyCode == 13) {
      submitFormReg(event);
    }
  });
  $(document).on('click', '.contact-action button', function(event) {
    event.preventDefault();
    submitFormReg(event);
  });

  // Валидация инпутов
  function testField($input, done, fail) {
    var val = $input.val();
    var type = $input.data('validate');

    switch (type) {
      case 'phone':
        if ($input.parents('form:first').is('[data-validate-phone]') || $('body').hasClass('page-is-rates') || $('body').hasClass('page-is-online-kassy') || $input.parents('form:first').is('[data-use-bitrix]')) {
          var isValid = validatePhone(val);
          if (isValid) {
            return done(type);
          }

          fail('Номер телефона должен состоять из 10 цифр, начиная с кода оператора');
        }
        break;
      // case 'string':
      //   var isValid = validateString(val);
      //   if (isValid) {
      //     if (goalForm.step2 && !$input.is(':focus')) {
      //       sendYaEvent('lead_step_2');
      //       goalForm.step2 = false;
      //     }
      //     return done(type);
      //   }
      //
      //   fail('Поле обязательно для заполнения');
      //   break;
      // case 'checkbox':
      //   var isValid = $input.prop('checked');
      //   console.log(isValid, $input);
      //   if (isValid) return done(type);
      //
      //   fail('Для продолжения нужно согласие с условиями');
      //   break;
      case 'email':
        var isValid = validateEmail(val);
        if (isValid) {
          if (goalForm.step3) {
            sendYaEvent('lead_step_3');
            goalForm.step3 = false;
          }
          return done(type);
        }

        fail('Введите корректный e-mail');
        break;
      default:
        done(type)
    }
  }

  $(document).on('click', '.js-registration-submit', function(event) {
    event.preventDefault();
    var form = $(this).parents('form:first');
    var mail = form.find('[name="email"]').val();
    var _contact = form.find('[name="contact"]').val();
    var isValid = validateEmail(mail);
    if (isValid && _contact == '') {
      //saveLead('+71111111111', 'Лид с формы попробовать бесплатно', null, mail, null, true)
    }
  });

  // Отправить лида в битрикс 24
  function saveLead(phone, NAME, LAST_NAME, EMAIL_WORK, doneCallback, isTest) {
    var dataCl = {
      LOGIN: 'vladimir.ivanin@insales.ru',
      PASSWORD: '2dercYwlC',
      TITLE: 'Лид с сайта ЕКАМ с e-mail',
      PHONE_MOBILE: phone,
      SOURCE_DESCRIPTION: window.location.href
    }

    if (typeof NAME == 'undefined' && goalForm.step1) {
      sendYaEvent('lead_step_1');
      goalForm.step1 = false;
      if (typeof phone !== 'undefined' && phone != '+71111111111') {
        dataCl.TITLE = 'Лид с сайта ЕКАМ с номером';
      }
    }

    if (typeof isTest != 'undefined') {
      dataCl.TITLE = 'Лид с сайта ЕКАМ с формы попробовать бесплатно';
    }

    if (window.location.pathname == '/page/online-kassa') {
      dataCl.TITLE = 'Консультация /page/online-kassa';
    }
    
    if (window.location.pathname == '/page/taxi') {
      dataCl.TITLE = 'Лид с сайта ЕКАМ с формы TAXI';
    }

    if (isSavedLead ) {
      if(typeof doneCallback == 'function'){
        doneCallback()
      }

      return
    }

    isSavedLead = true;

    if (NAME) {
      dataCl.NAME = NAME;
    }
    if (LAST_NAME) {
      dataCl.LAST_NAME = LAST_NAME;
    }
    if (EMAIL_WORK) {
      dataCl.EMAIL_WORK = EMAIL_WORK;
    }

    function logResults(res) {
      console.log(res);
    }

    try {
      $.ajax({
        url: 'https://ekam.bitrix24.ru/crm/configs/import/lead.php',
        type: 'GET',
        dataType: "jsonp",
        //contentType: 'application/json; charset=UTF-8',
        jsonpCallback: "logResults",
        data: dataCl
      })
      .done(function(success) {
        console.log(success);
        console.log('success');
      })
      .fail(function(error) {
        console.log(error);
        console.log('error');
      })
      .always(function(error) {
        console.log(error);
        console.log('always');
          setTimeout(function () {
          if (typeof phone !== 'undefined' && typeof doneCallback == 'function' || typeof EMAIL_WORK != 'undefined' && typeof doneCallback == 'function') {
            doneCallback()
          }
        }, 300)
      })
    } catch (e) {
      console.log('catch');
        setTimeout(function () {
          if (typeof phone !== 'undefined' && typeof doneCallback == 'function' || typeof EMAIL_WORK != 'undefined' && typeof doneCallback == 'function') {
            doneCallback()
          }
        }, 300)
    }
    if (!isSavedLead) {
    }
  }

  function validateEmail(email) {
    var mailReg = new RegExp(/^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/);
    
    var isValid = mailReg.test(email);
    return isValid;
  }

  function validatePhone(phone) {
    var phoneLen = 11;
    var realLen = getPhoneNumberLength(phone);

    return (phoneLen - realLen) === 0;
  }

  function validateString(value) {
    return (value && value != '');
  }

  function focusStatus($input) {
    var val = $input.val();
    //var phoneValid = (val && $input.is('[data-tel-field]')) ? val != '+7(___) ___-____' && val.indexOf('_') == -1 : true;

    var withValue = (val && val != '');
    var isFocus = $input.is(':focus');

    return (withValue || isFocus);
  }

  function getPhoneNumberLength(phone) {
    if (!phone) {
      phone = '';
    }else{
      phone = decodeURIComponent(phone.replace(/%(?!\d+)/g, '%25'));
    }

    var VRegExp = new RegExp(/[\d]/g);
    var VResult = phone.match(VRegExp);
    if (!VResult) {
      VResult = [];
    }

    return VResult.length;
  }


  var maskOptions =  {
    autoclear: false
  };

  

  // Ловим фокус
  $(document).on('click focusout focusin blur input blur.mask input.mask paste.mask', '.form-control input', function(event) {
    //event.preventDefault();
    var isFocus = focusStatus($(this));
    var $control = $(this).parents('.form-control');
    var activeClass = 'is-focus';
    var defaultClass = 'is-default';

    if (isFocus) {
      $control.addClass(activeClass).removeClass(defaultClass)
    }else {
      $control.addClass(defaultClass).removeClass(activeClass)
    }
  });

  // тестим состоние инпутов
  $('.form-control input').not('[type="checkbox"]').trigger('click');


  $(document).on('submit', '.callback', function(event) {
    event.preventDefault();

    var $phone = $(this).find('[name="phone-callback"]');
    var $mail = $(this).find('[name="mail"]');
    var TITLE = $(this).data('title-message');
    
    if ($phone.length) {
        var phone = $phone.val();
        var isValidPhone = validatePhone(phone);
        if (isValidPhone) {
          saveDealSimple(phone, null, TITLE);
          $(this).removeClass('with-error');
          $phone.val("");
        }else{
          $(this).addClass('with-error');
        }
    }

    if ($mail.length) {
      var mail = $mail.val();
      var isValidMail = validateEmail(mail);
      if (isValidMail) {
        saveDealSimple('+79999999999', mail, TITLE);
        $(this).removeClass('with-error');
        $mail.val("");
      }else{
        $(this).addClass('with-error');
      }
    }
    if ($(this).attr("data-ya-goal")) {
      var reach = $(this).attr("data-ya-goal");
      if (!$(".callback-error").is(':visible')){
        yaCounter28511841.reachGoal(reach);
      };
    };
  });
  
  $(document).on('submit', '.js-ekam-registration', function(event) {
    event.preventDefault();
    var $mail = $(this).find('[name="email"]');
    var mail = $mail.val();
    var isValidMail = validateEmail(mail);

    if (isValidMail) {
      $mail.removeClass('with-error');
    }else{
      $mail.addClass('with-error');
    }
 
    if (isValidMail) {
      var href = 'https://app.ekam.ru/registration?';
      href += 'email=' + mail;

      var rate = event.target.dataset.rate
      if (rate) {
        href+= '&rate=' + rate      
      }
      var planHandle = event.target.dataset.planHandle
      if (planHandle) {
        href+= '&plan_handle=' + planHandle      
      }
      href += '&uuid=' + generateUUID();

      //Записываем реферер из кук
      var landing_page = $.cookie('first_current_location').split('?')[0];
      if (landing_page) {
        href += '&landing_page=ekam.ru' + landing_page
      }
      var utm_fields = $.cookie('first_current_location').split('?')[1];
      if (utm_fields) {
        href += '&' + utm_fields
      }
      var referer_url = $.cookie('first_referer');
      if (referer_url.length > 1) {
        href += '&referer_url=' + referer_url;
      }
      href += '&registration_page=' + location.href
      location.href = href
    };
  })

  $(document).on('submit', '.js-calculation, .js-calculation-taxi', function(event) {
    event.preventDefault();
    console.log('obj');
    var $phone = $(this).find('[name="phone-calc"]');
    var $name = $(this).find('[name="name"]');
    var $mail = $(this).find('[name="mail"]');
    var TITLE = getTitle();

    var phone = $phone.val().replace(/[+\(\)\s-]/g, '');
    var name = $name.val();
    var mail = $mail.val();
    var comments = getComments()

    var isValidPhone = validatePhone(phone);
    var isValidMail = validateEmail(mail);

    if (isValidPhone) {
      $phone.removeClass('with-error');
    }else{
      $phone.addClass('with-error');
    }

    if (isValidMail) {
      $mail.removeClass('with-error');
    }else{
      $mail.addClass('with-error');
    }

    if (isValidPhone && isValidMail) {
      var href = 'https://app.ekam.ru/registration?';
      href += 'email=' + mail;
      href += '&registration_phone=' + phone
      var rate = event.target.dataset.rate
      if (rate) {
        href+= '&rate=' + rate      
      }
      var planHandle = event.target.dataset.planHandle
      if (planHandle) {
        href+= '&plan_handle=' + planHandle      
      }
      if (name) {
        href+= '&user_name=' + name
      }      
      if (TITLE) {
        href+= '&bitrix24_title=' + TITLE
      }
      if (comments) {
        href+= '&bitrix24_comment=' + comments
      }
      href += '&uuid=' + generateUUID();

      //Записываем реферер из кук
      var landing_page = $.cookie('first_current_location').split('?')[0];
      if (landing_page) {
        href += '&landing_page=ekam.ru' + landing_page
      }
      var utm_fields = $.cookie('first_current_location').split('?')[1];
      if (utm_fields) {
        href += '&' + utm_fields
      }
      var referer_url = $.cookie('first_referer');
      if (referer_url.length > 1) {
        href += '&referer_url=' + referer_url;
      }
      href += '&registration_page=' + location.href
      location.href = href
    }

    if ($(this).is(".js-calculation-taxi")){
     if (!$(".calculation-input").is(".with-error")){
       yaCounter28511841.reachGoal("reg-tel-3");
     };
    };
  });

  function getTitle() {
    var resultArray = [];

    $('.js-calculation-taxi, .js-calculation').each(function(index, el) {
      resultArray.push($(el).data('title-message'));
    });
    
    $('.js-calculation-taxi [name="name"], .js-calculation [name="name"]').each(function(index, el) {
      resultArray.push($(el).val());
    });

    $('.js-calculation input:checked').each(function(index, el) {
      resultArray.push($(el).data('price-item'));
    });
    
    $('.js-calculation-taxi input:checked').each(function(index, el) {
      if(!~$(el).data('price-item').indexOf('Число юр.лиц / ИП')) {
        resultArray.push($(el).data('price-item'));
      }
    });
    
    if($('.js-calculation-taxi').length){
      resultArray.push('сумма: ' + $('[data-year]').text());
    }
    return resultArray.join(', ');
  }
  
  function getComments() {
    var resultArray = [];

    $('.js-calculation input:checked').each(function(index, el) {
      resultArray.push($(el).data('price-item'));
    });
    
    $('.js-calculation-taxi input:checked').each(function(index, el) {
      resultArray.push($(el).data('price-item'));
    });
    
    if($('.js-calculation-taxi').length){
      resultArray.push('оборудование - ' + $('[data-year]').text());
    }
    resultArray.push('оборудование и услуги - ' + $('[data-year]').text());
    resultArray.push('при оплате за год: ' + $('[data-moth]').text());
    return resultArray.join(', ');
  }
  
  // Отправляем сделку в битрикс через app.ekam.ru
  function saveDealSimple(phone, email, title, name, comments) {
    setTimeout(function () {
      alertify.success('Успешно отправлено!')
    }, 300)
    
    var href = 'https://app.ekam.ru/bitrix24_deal?'
    
    if (phone) {
      href+= 'phone=' + phone + '&';
    }
    if (email) {
      href+= 'email=' + email + '&';
    }
    if (title) {
      href+= 'title=' + title + '&';
    }
    if (name) {
      href+= 'name=' + name + '&';
    }
    if (comments) {
      href+= 'comment=' + comments + '&';
    }
    var landing_page = $.cookie('first_current_location').split('?')[0];
    if (landing_page) {
      href += 'landing_page=ekam.ru' + landing_page + '&'
    }
    var utm_fields = $.cookie('first_current_location').split('?')[1];
    if (utm_fields) {
      href += utm_fields + '&'
    }
    var referer_url = $.cookie('first_referer');
    if (referer_url.length > 1) {
      href += 'referer_url=' + referer_url + '&';
    }
    href += 'registration_page=' + location.href + '&';
    
    href = href.slice(0, -1)

    try {
      $.ajax({
        url: href,
        type: 'GET'
      })
      .done(function(success) {
        console.log(success);
        console.log('success');
      })
      .fail(function(error) {
        console.log(error);
        console.log('error');
      })
      .always(function(error) {
        console.log(error);
        console.log('always');
      })
    } catch (e) {
      console.log('catch');
    }
  }
  
  // Отправить лида в битрикс 24
  function saveLeadSimple(phone, EMAIL_WORK, TITLE, NAME, COMMENTS) {
    setTimeout(function () {
      alertify.success('Успешно отправлено!')
    }, 300)
    var dataCl = {
      LOGIN: 'vladimir.ivanin@insales.ru',
      PASSWORD: '2dercYwlC',
      TITLE: TITLE, // Лид с сайта ЕКАМ с e-mail
      PHONE_MOBILE: phone,
      SOURCE_DESCRIPTION: window.location.href
    }

    if (EMAIL_WORK) {
      dataCl.EMAIL_WORK = EMAIL_WORK;
    }
    if (NAME) {
      dataCl.NAME = NAME;
    }
    if (COMMENTS) {
      dataCl.COMMENTS = COMMENTS;
    }

    try {
      $.ajax({
        url: 'https://ekam.bitrix24.ru/crm/configs/import/lead.php',
        type: 'GET',
        dataType: "jsonp",
        //contentType: 'application/json; charset=UTF-8',
        jsonpCallback: "logResults",
        data: dataCl
      })
      .done(function(success) {
        console.log(success);
        console.log('success');
      })
      .fail(function(error) {
        console.log(error);
        console.log('error');
      })
      .always(function(error) {
        console.log(error);
        console.log('always');
      })
    } catch (e) {
      console.log('catch');
    }
  }
}
function generateUUID() {
  var d = new Date().getTime();
  var uuid = 'xxxxxxxxxxxx4xxxyxxxxxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
    var r = (d + Math.random()*16)%16 | 0;
    d = Math.floor(d/16);
    return (c=='x' ? r : (r&0x3|0x8)).toString(16);
  });
  return uuid;
};

function fireClickEvent(element) {
    var evt = new window.MouseEvent('click', {
        view: window,
        bubbles: true,
        cancelable: true
    });

    element.dispatchEvent(evt);
}


function openNewTabOrNewWindow(targetURL) {
    var a = document.createElement('a');
    a.href = targetURL;

    a.target = '_blank'; // now it will open new tab/window and bypass any popup blocker!

    fireClickEvent(a);
}
